<?php
/*
============================================================
    Newsbox Rotator for CMSimple
============================================================
Version:    2.0.1  
Copyright:   Jerry Jakobsfeld 2008-2011
Website:    cmsimpleplugins.jakobsfeld.dk
Released under Remove Link License and Commercial License. Please read file license.txt included in distribution package. Visit cimsimpleplugins.jakobsfeld.dk to buy a licence.

Change summary:
version 1.0.0 released november 2008.

version 1.1.0 released january 2009
added cursor definition in plugin configurtion
added language section 
added explanation to mouseover action in language file
		
version 1.1.1 released january 2009
bug fix: cursor=auto, PauseRotation="" if only one newsbox found.

version 1.1.2 released january 2009
bug fix: solved path problems in multilanguage versions.

version 1.3.0 september 2010
Rewrited according to changes in CMSimple_XH ver. 1.2
Scheduling is not supported any more until CMSimple Team releases scheduling option in page_params plugin.

version 1.3.1
Code optimization
added time correction in language file.

version 2.0.0 July 2011
Rewrited to jQuery and jQuery.cycles plugin

version 2.0.1 August 2011
changed ids "newsrotator_content" and "newsrotator_content_first" to classes according to w3c recommendations. (concerned files: index.php and stylesheet.css) 
============================================================
*/
$newsrotator_content_arr=newsrotator_content();

if (sizeof($newsrotator_content_arr)>0) { //initiate jQuery if there are more then one news
	newsrotator_jQerylib();
}

function newsrotator_jQerylib()
{
	global $hjs, $pth, $plugin, $cf, $plugin_cf;
	
	include_once($pth['folder']['plugins'].'jquery/jquery.inc.php');
	include_jQuery();
	include_jQueryPlugin('cycle', $pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/js/jquery.cycle.all.min.js');
  if (($plugin_cf['newsrotator']['easing']	!= null) || ($plugin_cf['newsrotator']['easeIn']!=null) || ($plugin_cf['newsrotator']['easeOut']!= null) ) {
	include_jQueryPlugin('easing', $pth['folder']['base'].$cf['plugins']['folder'].'/'.$plugin.'/js/jquery.easing.1.3.js');
	}
	$hjs.=newsrotator_cycle_config();
}

function newsrotator_cycle_config()
{
	global $plugin_cf, $newsrotator_content_arr;
	$startingSlide=isset($_COOKIE['newsrotoator'])?$_COOKIE['newsrotoator']:0;
	if ($startingSlide>=sizeof($newsrotator_content_arr)) {
		$startingSlide=0;
	}
	$o.="\n<!--  initialize Newsbox Rotator -->
	<script type=\"text/javascript\">
		function createCookie(name,value) {
			document.cookie = name+\"=\"+value;
		}
		
		(function($) {
			$(document).ready(function() {
				$('#newsrotator').cycle({ 
		    	timeout: ".$plugin_cf['newsrotator']['timeout'].",
		    	startingSlide: ".$startingSlide.",
					cleartype: ".$plugin_cf['newsrotator']['cleartype'].", 
					randomizeEffects:".$plugin_cf['newsrotator']['randomizeEffects'].", 
					fx: '".$plugin_cf['newsrotator']['fx']."',";
					if ($plugin_cf['newsrotator']['fx_parm']!="") {
						$o.=" " .$plugin_cf['newsrotator']['fx_parm'].","; 
					}
					if (($plugin_cf['newsrotator']['speed']!==null) and ($plugin_cf['newsrotator']['speed']!="")) {
						$o.="speed: ".$plugin_cf['newsrotator']['speed'].",";
					}
					else { 
						$o.="speedIn: ".($plugin_cf['newsrotator']['speedIn']==null? "null" : $plugin_cf['newsrotator']['speedIn']) .", 
						speedOut: ".($plugin_cf['newsrotator']['speedOut']==null? "null" : $plugin_cf['newsrotator']['speedOut']) .","; 
					}
					if (($plugin_cf['newsrotator']['easing']	!= "") || ($plugin_cf['newsrotator']['easeIn']!="") || ($plugin_cf['newsrotator']['easeOut']!= "") ) {
						if (($plugin_cf['newsrotator']['easing']	!= "")) {
							$o.="easing: '".$plugin_cf['newsrotator']['easing']."',";
						}
						else { 
							$o.="easeIn: ".($plugin_cf['newsrotator']['easeIn']==""? "null": "'".$plugin_cf['newsrotator']['easeIn']."'" ) .", 
							easeOut: ".($plugin_cf['newsrotator']['easeOut']==""? "null": "'".$plugin_cf['newsrotator']['easeOut']."'" ) .", ";
						}
					}
					$o.="delay: ".$plugin_cf['newsrotator']['delay'].",
					sync: ".$plugin_cf['newsrotator']['sync'].",
					after: onAfter 
				});
				$('#newsrotator').mouseover(function() { 
		   		 $('#newsrotator').cycle('pause'); 
		   		 $('#newsrotator').css('cursor','".$plugin_cf['newsrotator']['cursor_mouseover']."');
				});
				$('#newsrotator').mouseout(function() { 
		   		 $('#newsrotator').cycle('resume'); 
				});
				function onAfter(curr,next,opts) {
					createCookie('newsrotoator',opts.currSlide+1);
				}
			});
		})(jQuery);
	</script>\n";
	return $o;
}

function newsrotator_content() 
{
	global $newsrotator_count, $pd_router, $plugin, $cl, $c, $h, $l, $cf, $plugin_cf, $plugin_tx;
	
	$i=1; // ommit Welcome page
	$arr=array();
	
	while ($i<$cl && $l[$i]!=1) {// read all content 
	  if (strpos("x".strtolower($h[$i]),$plugin_cf['newsrotator']['newsbox_name'])) {  // if newsbox_name is a part of the title
	  	$scheduled = true;
	    if (isset($pd_router)) { 
	    	$page = $pd_router -> find_page($i);
	    	if ($page['published']!=='0') {
	    		if (isset($page['publication_date'])) { //publication_date and expires are not supported by CMSimple page_params plugin yet
		    		$timezone=(intval($plugin_tx['newsrotator']['time_correction']) + intval(date("I")))*60*60;	
						$current = intval(strtotime(gmstrftime ("%Y-%m-%d %H:%M")))+$timezone;	
						if (!defined('PHP_INT_MAX'))
							define('PHP_INT_MAX',intval('9223372036854775807'));
						$publication_date= (trim($page['publication_date'])!="") ? strtotime($page['publication_date']) : 0;  
						$expiration_date=  (trim($page['expires'])!="") ? strtotime($page['expires']) : PHP_INT_MAX; 
						$scheduled = ($current>$publication_date && $current<$expiration_date);
					}
	    	}
				else 	$scheduled = false;				
			}	// end of if page_params plugin is installed and publication_date is a part of page_params plugin
			if ($scheduled) { 
				$txt= preg_replace("/(<(.*?)>)?".$cf['scripting']['regexp']."(<\/(.*?)>)?/is", "", preg_replace("/.*<\/h[1-".$cf['menu']['levels']."]>/i", "", $c[$i]));
				$txt=preg_replace("/<\s*div/i","<p",$txt);
				$txt=preg_replace("/<\s*\/div\s*>/i","</p>",$txt);
	     	if (trim($txt!="")) {
	     		$arr[]=$txt; 
	     	}
	    }
	  }
	  ++$i;
	}
	return $arr;
}

function newsrotator() 
{
	global $pth, $plugin_tx, $newsrotator_content_arr;
	
	//$newsrotator_content=newsrotator_content();
	$newsrotator_content="";
	if (sizeof($newsrotator_content_arr)>0) {
		//check existence of jQuery plugin
		$jqerror = ''; 
	  if(!file_exists($pth['folder']['plugins'].'jquery/jquery.inc.php')){  
		  $jqerror = '<div class="cmsimplecore_warning">'.  
	                  '<b>Ups!</b>'.tag('br').  
	                  'Plugin '.ucfirst(basename(dirname(__FILE__))).  
	                  ' requires jQuery4CMSimple - Plugin!'.tag('br').  
	                  'Please download and install jQuery4CMSimple'.tag('br').  
	                  'from <a href='.  
	                  '"http://cmsimple-xh.com/wiki/doku.php/plugins:jquery4cmsimple">'.  
	                  ' www.cmsimple-xh.com/wiki</a>.'.  
	                  '</div>';  
    	return($jqerror);  //drop the rest of the plugin-code  
		} 
		else {
			if (sizeof($newsrotator_content_arr)==1) {
				$plugin_tx['newsrotator']['pause_rotation']=""; // no title on single news
			}
			for ($i=0; $i<sizeof($newsrotator_content_arr);$i++) {
				$newsrotator_content.='<div class="newsrotator_content'.(($i==0)?"_first":"").'" title="'.$plugin_tx['newsrotator']['pause_rotation'].'">'.$newsrotator_content_arr[$i].'</div>';
			}
			$style="newsrotator";
			$o='<!--Newsbox Rotator-->';
			$o.='<div id="newsrotator_container"><div id="'.$style.'">'.$newsrotator_content.'</div>';
		  $o.='<p id="nrtcrd"><a href="http://cmsimpleplugins.jakobsfeld.dk">Newsbox Rotator for CMSimple'.tag(br).'v.2 &copy; Jerry Jakobsfeld</a></p></div><!--Newsbox Rotator END-->';
			return $o; 
		}
	}
	return "";
}
?>